class ElectionStruct < ActionWebService::Struct
  member :name, :string
  member :description, :string
  member :candidate_ids, [:int]
  member :candidate_names, [:string]
  member :id, :int
end
class VoteInfo < ActionWebService::Struct
  member :voter_id, :int
  member :voter_ipaddress, :string
  member :vote_time, :int
  member :vote, [:int]
end

class VoteResultStruct < ActionWebService::Struct
  member :plurality_winners, [:int]
  member :approval_winners, [:int]
  member :condorcet_winners, [:int]
  member :ssd_winners, [:int]
  member :borda_winners, [:int]
  member :errors, [:string]
end
class CandidateMap < ActionWebService::Struct
  member :candidate_ids, [:int]
  member :candidate_names, [:string]
  member :errors, [:string]
end
class SelectricityAPI < ActionWebService::API::Base
  api_method :cast_quickvote, :expects => [:string, :int, [[:int]]], :returns => [:string]
  api_method :get_quickvote_results, :expects => [:string], :returns => [VoteResultStruct]
  api_method :get_quickvote_candidate_map, :expects => [:string], :returns => [CandidateMap]
  api_method :quickvote_candidate_ids_to_names, :expects => [:string,[:int]], :returns => [[:string]]
  api_method :get_quickvote_votes, :expects => [:string], :returns => [ [VoteInfo] ]
  api_method :list_quickvotes, :expects => [], :returns => [[ElectionStruct]]
  api_method :get_quickvote, :expects => [:string], :returns => [ElectionStruct]
  api_method :create_quickvote, :expects => [ElectionStruct], :returns => [:string]
end


